
// OpenGLPickView.h : COpenGLPickView NX̃C^[tFCX
//

#pragma once

//#include "OpenGLTrackView.h"
#include "OpenGLLightView.h"

#define	NAMEARRAYSIZE			(10)	// Ȏ傫
#define PICKREGIONOFFSET		(5)		// sbN̈̃ItZbg
#define PICKREGIONPIXELCOUNT	( 1 + 2 * PICKREGIONOFFSET ) * ( 1 + 2 * PICKREGIONOFFSET )	// sbN̈̃sNZ

// Render Mode
enum ERENDERMODE
{
	RM_UNDEFINED = 0,
	RM_RENDER,			// ʏ`
	RM_PICK_GROUPID,	// sbN`iO[vԍj
	RM_PICK_ELEMENTTYPE,// sbN`ivf^Cvj
	RM_PICK_ELEMENTID,	// sbN`ivfԍj
};

enum ERENDERELEMENTTYPE
{
	RET_UNDEFINED = 0,
	RET_POINT,
	RET_LINE,
	RET_FACE,
};

class COpenGLPickView : public COpenGLLightView
{
	// oϐ
private:
	GLuint			m_uiTextureID;
	GLuint			m_uiRenderBufferID;
	GLuint			m_uiFrameBufferID;
protected:
	unsigned int	m_auiName_picked[NAMEARRAYSIZE];	// sbNꂽvf̖O

	// o֐
private:
	void	CreateFrameBuffer( int iWidth, int iHeight );
	void	DestroyFrameBuffer();
	bool	RenderScene();
	int		DoPicking( int x, int y );
protected:
	virtual void	UninitializeOpenGL();
	virtual void	RenderModel( ERENDERMODE eRenderMode );
	virtual void	IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int  aauiNamePickRegionPixel[][NAMEARRAYSIZE] );

protected: // VÂݍ쐬܂B
	COpenGLPickView();
	DECLARE_DYNCREATE(COpenGLPickView)

// 
public:
	CDocument* GetDocument() const;

// 
public:

// I[o[Ch
public:
//	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~COpenGLPickView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnSize( UINT nType, int cx, int cy );
	afx_msg void OnRButtonUp( UINT nFlags, CPoint point );
};

#ifndef _DEBUG  // OpenGLPickView.cpp ̃fobO o[W
inline CDocument* COpenGLPickView::GetDocument() const
   { return reinterpret_cast<CDocument*>(m_pDocument); }
#endif

